package samsung_hbb_next_im.samsung_im2;



import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.StrictMode;
import android.os.Vibrator;
import android.text.Layout;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class ChatScreen extends Activity {
	
	TextView messages;
	EditText inputMessage;
	public static String server_ip = "147.175.158.249";
	public static String server_port = "5555";
	private int m_interval = 5000; // 5 seconds by default, can be changed later
	private Handler m_handler;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.chat_screen);  
        
        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);
        messages = (TextView)findViewById(R.id.messages); 
        messages.setMovementMethod(new ScrollingMovementMethod());
        
        TextView user = (TextView) findViewById(R.id.myUser);
        
        Intent setUser = getIntent();
        String myUser = setUser.getStringExtra("userName");
		String chatUser = setUser.getStringExtra("chatting_user");
        System.out.println("User=" + chatUser);
        user.setText("Pouzivatel: " + myUser + "  " + "Komu:" + chatUser);
        
		userSendMessage(chatUser);
		m_handler = new Handler();
        startRepeatingTask();		
    }
	
	Runnable m_statusChecker = new Runnable()
	 {
	      public void run() {
	    	  new BackgroundLifting().execute();; //this function can change value of m_interval.
	           m_handler.postDelayed(m_statusChecker, m_interval);
	      }
	 };

	 void startRepeatingTask()
	 {
	     m_statusChecker.run(); 
	 }

	 void stopRepeatingTask()
	 {
	     m_handler.removeCallbacks(m_statusChecker);
	 }
	 @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        getMenuInflater().inflate(R.menu.activity_main, menu);
	        return true;
	    }
	 public boolean onOptionsItemSelected(MenuItem item) {
	        switch (item.getItemId()) {
	        case R.id.log_out:
	        	userLogOut();
	        	Intent setUserActivity = new Intent(getApplicationContext(), SetUserActivity.class);
	        	startActivity(setUserActivity);
	        	return true;        
	        default:
	        	return super.onOptionsItemSelected(item);
	        }
	    }
	 private void vypis(String sprava)
	 {     
	        if(messages != null){
	        	 messages.append(sprava);	        
	        final Layout layout = messages.getLayout();
	        if(layout != null){
	            int scrollDelta = layout.getLineBottom(messages.getLineCount() - 1) 
	                - messages.getScrollY() - messages.getHeight();
	            if(scrollDelta > 0)
	            	messages.scrollBy(0, scrollDelta);
	        	}
	        }
	 }
	 
	 
	 private void userSendMessage(final String chatUser){
	    	Button btnConfirmUser = (Button) findViewById(R.id.sendMessage);
	    	btnConfirmUser.setOnClickListener(new View.OnClickListener() {
	    		StringBuilder builder = new StringBuilder();
	    		public void onClick(View arg0) {	    			
	    				    			
	    			inputMessage = (EditText) findViewById(R.id.setUsername);
	    			String message = inputMessage.getText().toString();
	    			System.out.println("Sprava na poslanie:" + message);
	       		    HttpClient client = new DefaultHttpClient();
	       		    try {
						message = URLEncoder.encode(message, "utf-8");
					} catch (UnsupportedEncodingException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
	       		    HttpGet httpGet = new HttpGet("http://"+ server_ip +":" + server_port + "/SrvcM/message?send&to="+ chatUser +"&msg=" + message);
	       		    System.out.println("http://"+ server_ip +":" + server_port + "/SrvcM/message?send&to="+ chatUser +"&msg=" + message);
	       		    try {
	       		      HttpResponse response = client.execute(httpGet);
	       		      StatusLine statusLine = response.getStatusLine();
	       		      int statusCode = statusLine.getStatusCode();       		      
	       		      if (statusCode == 200) {
	       		    	HttpEntity entity = response.getEntity();
	       		    	message = URLDecoder.decode(message, "utf-8");
	       		    	vypis("Ja:"+":\n"+message + "\n");
	       		    	InputStream content = entity.getContent();
	       		    	BufferedReader reader = new BufferedReader(new InputStreamReader(content));
	       		        String line;
	       		        while ((line = reader.readLine()) != null) {
	       		          builder.append(line);
	       		        }
	       		      	System.out.println(builder.toString());
	       		      } else {
	       		        Log.e(SetUserActivity.class.toString(), "Failed to download file");
	       		      }
	       		    } catch (ClientProtocolException e) {
	       		      e.printStackTrace();
	       		    } catch (IOException e) {
	       		      e.printStackTrace();
	       		    }       	
	    		}
	    	});    				   
	    }
	 
	 public void userLogOut(){    		
			Intent i = getIntent();
			// Receiving the Data
			String loggedUser = i.getStringExtra("userName");
		    HttpClient client = new DefaultHttpClient();
		    HttpGet httpGet = new HttpGet("http://"+server_ip+":" + server_port + "/SrvcM/sign?out=" + loggedUser);
		    try {
		      HttpResponse response = client.execute(httpGet);
		      StatusLine statusLine = response.getStatusLine();
		      int statusCode = statusLine.getStatusCode();
		      if (statusCode == 200) {
		        HttpEntity entity = response.getEntity();       		               		        
		      } else {
		        Log.e(LoggedUserActivity.class.toString(), "Failed to download file");
		      }
		    } catch (ClientProtocolException e) {
		      e.printStackTrace();
		    } catch (IOException e) {
		      e.printStackTrace();
		    }       		 
	 }
	 
	 
	 private class BackgroundLifting extends AsyncTask<Void, Void, String> {

			public static final String server_ip = "147.175.158.249";
			public static final String server_port = "5555";
			
			@Override
			protected String doInBackground(Void... params) {
				String message = null;
				try {
					message = userReceiveMessage();
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return message;
			}
			
			protected void onPostExecute(String result) {
				if (result != "")
					vypis(result+ "\n");
		    }
			
			private String userReceiveMessage() throws JSONException{
				
				String message = "";				 
		 		StringBuilder builder = new StringBuilder();
       		    HttpClient client = new DefaultHttpClient();
       		    HttpGet httpGet = new HttpGet("http://"+ server_ip +":" + server_port + "/SrvcM/message?receive");	       		    
       		    try {
       		      HttpResponse response = client.execute(httpGet);
       		      StatusLine statusLine = response.getStatusLine();
       		      int statusCode = statusLine.getStatusCode();       		      
       		      if (statusCode == 200) {
       		    	HttpEntity entity = response.getEntity();
       		    	InputStream content = entity.getContent();
       		    	BufferedReader reader = new BufferedReader(new InputStreamReader(content));
       		        String line;
       		        while ((line = reader.readLine()) != null) {
       		          builder.append(line);
       		        }
       		        message = builder.toString();
       		        JSONArray jsonArray = new JSONArray(message);	       		     
	       		    JSONObject jsonObject = jsonArray.getJSONObject(0);
    		        if(jsonObject.has("error") || jsonObject.has("info"))
    		        {    		        	
    		        	System.out.println("Sprava  = "+ message);
    		        	message = "";
    		        }
    		        else if (jsonObject.has("from"))
    		        {
    		        	System.out.println("Sprava2  = "+ message);
    		        	String messagik = URLDecoder.decode(jsonObject.getString("msg"), "utf-8");
    		        	message = jsonObject.getString("from") +":\n" +  messagik;
    		        	Vibrator v = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
    		        	v.vibrate(300);
    		        }
    		        	return message;
       		      } else {
       		        Log.e(SetUserActivity.class.toString(), "Failed to download file");
       		      }
       		    } catch (ClientProtocolException e) {
       		      e.printStackTrace();
       		    } catch (IOException e) {
       		      e.printStackTrace();
       		    }
				return message;  		   
    }
			
		}

}
