package samsung_hbb_next_im.samsung_im2;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.ListActivity;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.StrictMode;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

public class LoggedUserActivity extends ListActivity {
	
	String[] contactList;
	private int m_interval = 5000; // 5 seconds by default, can be changed later
	private Handler m_handler;
	public static final String server_ip = "147.175.158.249";
	public static final String server_port = "5555";	
	
	 @Override
	 public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        
	        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
	        StrictMode.setThreadPolicy(policy);  
	        
	        
	        new ContactListThread().execute();
	        m_handler = new Handler();
	        startRepeatingTask();
	 }
	 
	 Runnable m_statusChecker = new Runnable()
	 {
	      public void run() {
	    	  new ContactListThread().execute(); //this function can change value of m_interval.
	           m_handler.postDelayed(m_statusChecker, m_interval);
	      }
	 };

	 void startRepeatingTask()
	 {
	     m_statusChecker.run(); 
	 }

	 void stopRepeatingTask()
	 {
	     m_handler.removeCallbacks(m_statusChecker);
	 }
	 	
	 public void zobraz(String[] contacts) //zobrazi kontakty
	 {
		 this.setListAdapter(new ArrayAdapter<String>(this, R.layout.logged_user_screen, R.id.label, contacts));
		    
		    ListView lv = getListView();
		    
		    lv.setOnItemClickListener(new OnItemClickListener() {
		          public void onItemClick(AdapterView<?> parent, View view,
		              int position, long id) {
		 
		              // selected item
		              String chatting_user = ((TextView) view).getText().toString();
		              System.out.println("Userlogged=" + chatting_user);
		              // Launching new Activity on selecting single List Item
		              String[] user = chatting_user.split(" ");		              
		              Intent i = new Intent(getApplicationContext(), ChatScreen.class);
		              // sending data to new activity	
		              Intent before = getIntent();
		          	  String myUser = before.getStringExtra("userName");
		              i.putExtra("userName", myUser);
		              i.putExtra("chatting_user", user[0]);
		              startActivity(i);		             
		          }
		        });
	 }
	 
	 @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        getMenuInflater().inflate(R.menu.activity_main, menu);
	        return true;
	    }
	    
	    public boolean onOptionsItemSelected(MenuItem item) {
	        switch (item.getItemId()) {
	        case R.id.log_out:
	        	userLogOut();
	        	Intent setUserActivity = new Intent(getApplicationContext(), SetUserActivity.class);
	        	startActivity(setUserActivity);
	        	return true;        
	        default:
	        	return super.onOptionsItemSelected(item);
	        }
	    }
	    
	    public void userLogOut(){    		
  			Intent i = getIntent();
			// Receiving the Data
			String loggedUser = i.getStringExtra("userName");
   		    HttpClient client = new DefaultHttpClient();
   		    HttpGet httpGet = new HttpGet("http://"+server_ip+":" + server_port + "/SrvcM/sign?out=" + loggedUser);
   		    try {
   		      HttpResponse response = client.execute(httpGet);
   		      StatusLine statusLine = response.getStatusLine();
   		      int statusCode = statusLine.getStatusCode();
   		      if (statusCode == 200) {
   		        HttpEntity entity = response.getEntity();       		               		        
   		      } else {
   		        Log.e(LoggedUserActivity.class.toString(), "Failed to download file");
   		      }
   		    } catch (ClientProtocolException e) {
   		      e.printStackTrace();
   		    } catch (IOException e) {
   		      e.printStackTrace();
   		    }       		 
   	 }
	
	
	private class ContactListThread extends AsyncTask<Void, Void, String[]> {

		public static final String server_ip = "147.175.158.249";
		public static final String server_port = "5555";
		
		@Override
		protected String[] doInBackground(Void... params) {
			String[] contacts = getContList();
			return contacts;
		}
		
		protected void onPostExecute(String[] result) {
			zobraz(result);
	    }
				
		private String[] getContList(){	
			
			String[] contactList = null;	
			StringBuilder builder = new StringBuilder();
			    HttpClient client = new DefaultHttpClient();
			    HttpGet httpGet = new HttpGet("http://"+ server_ip +":" + server_port + "/SrvcM/contactList");
			    try {
			      String cele;	
			      HttpResponse response = client.execute(httpGet);
			      StatusLine statusLine = response.getStatusLine();
			      int statusCode = statusLine.getStatusCode();
			      if (statusCode == 200) {
			    	HttpEntity entity = response.getEntity();
			        InputStream content = entity.getContent();
			        BufferedReader reader = new BufferedReader(new InputStreamReader(content));
			        String line;
			        while ((line = reader.readLine()) != null) {
			          builder.append(line);
			        }
			        cele = builder.toString();       		        
			        System.out.println("kontakt = "+ cele);
			     try {
					JSONArray jsonArray = new JSONArray(cele);
					contactList = new String[jsonArray.length()];
					System.out.println("Number of entries " + jsonArray.length());
					 Intent before = getIntent();
		          	 String myUser = before.getStringExtra("userName");
					 for (int i = 0; i < jsonArray.length(); i++) {       
						 JSONObject jsonObject = jsonArray.getJSONObject(i);
						 if (jsonObject.has("username"))
				            {
							 if(jsonObject.getString("ip").regionMatches(0, "none", 0, 4))
							 {
								 contactList[i] = jsonObject.getString("username") + " Offline";
								 //j++;
							 }
							 else //if (!(jsonObject.getString("username").equals(myUser)))
							 {
								 contactList[i] = jsonObject.getString("username") + " Online";					            
							 }
							 //System.out.println(j);
							 System.out.println(contactList[i]);
				            }
					 }
					 return contactList;
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			      } else {
			        Log.e(ContactListThread.class.toString(), "Failed to download file");
			      }
			    } catch (ClientProtocolException e) {
			      e.printStackTrace();
			    } catch (IOException e) {
			      e.printStackTrace();
			    }
			return contactList;       		 
		 }
	}        
  }